### SCons SEP Environment
## The SEPTop part of this file defines the construction environment
## (environment variables, compiler flags, preprocessor stuff)
## The SEPBottom part of this file creates rules for buliding objects and executables
## from all of the F90 code in SRCDIR specified in the SConstruct file.
## It also creates rules for building f90 files from rs and rt files.

import SCons
import re
import os
import glob
import string
import SCons.Node.FS
import SCons.Scanner.Fortran

import SEPDefs
import SEPProg
from SEPFlow import *
from SEPtex import *
from SEPbook import *

def SEPTop(env,languages=['f90','lop','ratfor']):
    SEPDefs.sep_defs(env)
    if (('f90' or 'lop' or 'ratfor') in languages):
        SEPDefs.f90_defs(env)
    if ('ratfor' in languages):
        SEPDefs.ratfor_defs(env)
        SEPProg.createRSRTFileBuilders(env)
    if ('lop' in languages):
        SEPDefs.loptran_defs(env)
        SEPProg.createLOPFileBuilder(env)
    elif ('c' in languages):
          SEPDefs.c_defs(env)
    SEPDefs.seplib_defs(env)

def SEPBottom(env,objects='yes',programs='yes'):
    SEPDefs.bottom_defs(env)
    SEPDefs.find_src(env)
    SEPProg.generate_rules(env,objects,programs)
