clear all;
load ../Data/data1;

data=1./data1;

DR = sparse([2:125,1:124],[1:124,1:124],[ones(1,124),-ones(1,124)]);
DD = sparse([1:899,1:899],[2:900,1:899],[ones(1,899),-ones(1,899)]);
zz = diag(sparse(1:900));
weight2=diag(sparse(12./(1:900)));

velavg=1.45+0.*data;
velavg1=1.45+.0015.*zz*velavg;
velmax=1.2*velavg1;
velmin=.8.*velavg1;

cd ./cvx

cvx_begin

variables u(900,125) v(900,125)

w1=weight2 * ( v - zz * (data.^2) );
w2 = ( 3 * DD ) * u;
w3 = u * ( DR * 5 );

ww = [ vec( w1 ) ; vec( w2 ) ; vec( w3 )];
minimize( norm(ww));
[ v(1,:) ; DD * v ] == u;
u >= velmin.*velmin;
u <= velmax.*velmax;

cvx_end
cd ..

vint=sqrt(u);

H = givemeasepstruct([0.0 7.705], [0.004 0.067], vint);
swrite(H,'/net/koko/wrk1/sep125/ben1/matlab/L2vint-cvx-bounded.HH')


y=.004*[1:900];
x=7.705+.067*[1:125];
imagesc(x,y,vint);
xlabel('midpoint (km)');
ylabel('time (sec)');
colormap(gray);
colorbar;
