program Blocky 
  use sep
  use blocky_l1
  use bin1

  implicit none
  integer                          :: i1, i2, n1, n2, niter, stat, nq
  real                             :: eps,alpha,maxvint
  real, dimension (:), allocatable :: vint, vintb
  real, dimension (:), pointer     :: err, res

  call sep_init ()
  call from_history (n1)
  call from_either ("n2",n2,1)

  call from_par ("niter",niter,20)
  call from_par ("nq",nq,5)
  call from_par ("eps",eps,1.)
  call from_par ("alpha",alpha,1.)

  call to_history ("title","Blocky Interval velocity")
  call to_history ("n1",n1)
  call to_history ("d1",1)
  call to_history ("o1",0.002)

  allocate( vint(n1), vintb(n1), err(niter), res(n1))

	 vint = 0; vintb=0; err=0; res=0

     call sep_read (vint); vint = 1.e06/vint; maxvint=(maxval(vint)); vint=vint/maxvint
     call blocky( niter, eps, vintb, vint, err, res, nq, alpha )
     vintb=vintb*maxvint
     vint=vint*maxvint
     call sep_write (vintb) 
     if( exist_file("res") ) call sep_write( res, "res")
     if( exist_file("res") ) then
		call to_history ("n1",n1,"res")
		call to_history ("n2",1,"res")
     end if
     if( exist_file("vint") ) call sep_write( vint, "vint")
     if( exist_file("vint") ) then
		call to_history ("n1",n1,"vint")
		call to_history ("n2",1,"vint")
		call to_history ("d1",1,"vint")
		call to_history ("o1",0.002,"vint")
     end if


  call sep_close ()
  
  deallocate (vint, vintb, err, res)
  call exit (0)


end program Blocky 

