!--------------------------------------------------------
!Kind of works 
!No regularization operator
!--------------------------------------------------------
module NewsolverA
 
  use sep
  use igradx
  use igradt
  use cgmeth2d
  use solver_smp_mod
  use cgstep_mod
  
  implicit none
  contains 
    subroutine NewsolverA_test(m,d,Fop,w,niter,maxiter,epsx,epst,n1,n2,done)
      optional ::    w,                                         done
      interface
         integer function Fop(adj,add,m,d)
           real, dimension(:) :: m,d
           logical,intent(in) :: adj,add
         end  function Fop
      end interface
      
      real, dimension(:),   intent(in)  :: d
      real, dimension(:),   intent(out) :: m
      real,                 intent(in)  :: epsx, epst,done
      integer,              intent(in)  :: niter,n1,n2,maxiter
      integer                           :: stat,i,j,n, iter,q!,maxiter
      real                              :: fin, phi, mu, newphi,t,gap,tt,tx
      real, dimension(:),   allocatable ::  Fm, z, Ftz
      real, dimension(:),   pointer     :: dmt,dmx,uttmp,uxtmp
      real, dimension(:),   allocatable :: mtmp, nu, utmp
      real, dimension(:),   allocatable :: g1,delu,delm,ux,ut
      real, dimension(:),   allocatable :: dutmp,test,test1,u
      real, dimension(:),   pointer     :: alldel, allg, res,ones
      real                              :: x, y, eta, s, alpha, beta, smin,maxnu,tol, r,p
      real, dimension(:)   ::w!,intent(in)  :: w
      real, dimension(:,:), pointer     :: allH, allT,D1,id
          
      call sep_init()
      n=n1*n2
      allocate(allT(n1,n1),res(n1*n2),alldel(n1*n2))
      allocate(allH(n1,n1),D1(n1,n1))
      allocate (allg(n1*n2))
      allocate (ux(n),ut(n),uxtmp(n),uttmp(n))
      allocate(z(n),Fm(n),Ftz(n),u(n))
      allocate(mtmp(n),utmp(n),nu(n))
      allocate(g1(n),delu(n),delm(n))
      allocate(dmt(n),dmx(n))   
      allocate(ones(n1*n1),test(n1*n1),test1(n1*n1),id(n1,n1))
      
      !line search parameters
      alpha=.01
      beta = .5
      smin= .5
      mu=2
      w=1
      !maxiter=100
      !initializations
      t=1./(epsx+epst)
      tx=1./epsx
      tt=1./epst
      m=0.0
      u=1.0
      ut=1
      ux=1
      eta=2
      if (present(done)) then
         fin=done
      else
         fin=.1
      end if
      
      id=0
      do i=1,n1
         do j=1,n1
            if (j==i) then
               id(i,j)=1
            end if
         end do
      end do
      
      ones=reshape(id,(/n1*n1/))
      
      stat=Fop(.false.,.false.,ones,test)
      stat=Fop(.true.,.false.,test1,test)
      allH=reshape(test1,(/n1,n1/))
      
      s=1
      stat = Fop(.false.,.false.,m   ,Fm)
      delm=0
       
      do iter=1,niter ! Go till number of iterations is reached
                      ! If it doesn't stop before
         write(0,*) "iteration", iter
         
         z=(Fm-d)
         stat = Fop(.true.,.false.,Ftz,2.*z)
         call to_history("n1",n1,"ee.H")
         call to_history("d1",0.004,"ee.H")
         call to_history("n2",n2,"ee.H")
         call to_history("n3",niter,"ee.H")
         call srite("ee.H",z,n*4)
         call to_history("n1",n1,"ModelNoReg.H")
         call to_history("d1",0.004,"ModelNoReg.H")
         call to_history("n2",n2,"ModelNoReg.H")
         call to_history("n3",niter,"ModelNoReg.H")
         call srite("ModelNoReg.H",sqrt(m),n*4)
         stat=igradt_lop(.false.,.false.,m,dmt,n1,n2)
         stat=igradx_lop(.false.,.false.,m,dmx,n1,n2)
         !dmt=m
         !dmx=m
         ut=(1./(t*epst)+sqrt(dmt**2+(1./(t*epst))**2))
         ux=(1./(t*epsx)+sqrt(dmx**2+(1./(t*epsx))**2))
         !ut=ux
         !dmt=dmx
         nu=2.*z
         stat= Fop(.true.,.false.,dutmp,nu)
         maxnu=(maxval(dutmp))
         !write(0,*) "maxnu", maxnu
         if ((maxnu) > (epsx+epst)) then
            nu=nu*(epsx+epst)/maxnu
            write(0,*) "INNNNNNNNNNNNNNNNNNNNNNNN LOOP"
         end if
         x=sum(w*(z)**2)+(epst)*sum(ut)+epsx*sum(ux)
         write(0,*) "x", x
         !write(0,*) "yy", -.25*sum(w*nu**2)-sum(w*nu*d)
         !r=-.25*sum(w*nu**2)
         !p=-sum(w*nu*d)
         !y=r+p
         y=-.25*sum(w*nu**2)-sum(w*nu*d)!,y)
         eta=(x-y)
         write(0,*) "y", y
         write(0,*) "eta", eta
         gap=(eta/y)
         
         write(0,*) "gap", gap
         if (abs(gap) < .0001 .and. iter > 1) then
            write(0,*) "gap is little"
            exit
            write(0,*) "MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM"
            write(0,*) "SHOULD EXIT"
         end if
         
         if (s >= smin) then
            t=max(min(2.*mu*n1/eta,mu*t),t)
         end if
         if (s >= smin) then
            tt=max(min(2.*mu*n1/eta,mu*tt),tt)
         end if
         if (s >= smin) then
            tx=max(min(2.*mu*n1/eta,mu*tx),tx)
         end if
                 
         D1=0
         !D2=0
         do i=1,n1
            do j=1,n1
               if (i==j) then
                  D1(i,j)=2.*(ut(i)**2+dmt(i)**2)/((ut(i)**2-dmt(i)**2)**2)+2.*(ux(i)**2+dmx(i)**2)/((ux(i)**2-dmx(i)**2)**2)
                  !D2(i,j)=-4.*(ux(i)*dmx(i))/((ux(i)**2-dmx(i)**2)**2)-4.*(ut(i)*dmt(i))/((ut(i)**2-dmt(i)**2)**2)
               end if
            end do
            !H(i)=2.*t*H(i)+D1(i,i)
         end do
         
         g1=t*w*Ftz+2*dmt/((ut**2-dmt**2))+2*dmx/((ux**2-dmx**2))
         do i=1,n1
            do j=1,n1
               allT(i,j)=w(j)*allH(i,j)*2.0*(t)+D1(i,j)
            end do
         end do
         
         call to_history("n1",n1,"a.H")
         call to_history("d1",0.004,"a.H")
         call to_history("n2",n2,"a.H")
         call to_history("n3",niter,"a.H")
         call srite("a.H",dmx,n*4)
         call to_history("n1",n1,"b.H")
         call to_history("d1",0.004,"b.H")
         call to_history("n2",n2,"b.H")
         call to_history("n3",niter,"b.H")
         call srite("b.H",ux,n*4)
         call to_history("n1",n1,"c.H")
         call to_history("d1",0.004,"c.H")
         call to_history("n2",n2,"c.H")
         call to_history("n3",niter,"c.H")
         call srite("c.H",dmt,n*4)
         call to_history("n1",n1,"d.H")
         call to_history("d1",0.004,"d.H")
         call to_history("n2",n2,"d.H")
         call to_history("n3",niter,"d.H")
         call srite("d.H",ut,n*4)
         
         !tol=(.01*eta)/(sum(sqrt(g1**2)))
         !write(0,*) "tol", tol
         !------------------------------------------------------------------------
         
         call cgtest2d(alldel,-(g1), res, allT, niter=maxiter,n1=n1,n2=n2,mm=delm)!,tol=tol) ! ,mm=-g1/(H))
         
         !---------------------------------------------------------------------------
         delm=alldel
        
         !##################################################################################################################
         
         phi=sum((w*(z)**2))+epst*sum(ut)-sum(log(((ut**2-dmt**2))))/t-sum(log(((ux**2-dmx**2))))/t+epsx*sum(ux)
         s=1
         q=0
         do while (q <= 200)
            q=q+1
            mtmp=m+s*delm
            stat = Fop(.false.,.false.,mtmp ,Fm)
            
            stat=igradt_lop(.false.,.false.,mtmp,dmt,n1,n2)
            stat=igradx_lop(.false.,.false.,mtmp,dmx,n1,n2)
            !dmx=mtmp
            !dmt=mtmp
            uttmp=(1./(t*epst)+sqrt(dmt**2+(1./(t*epst))**2))
            uxtmp=(1./(t*epsx)+sqrt(dmx**2+(1./(t*epsx))**2))
            utmp=(1./(t*epst)+sqrt(m**2+(1./(t*epst))**2))
            !uttmp=uxtmp
            !dmt=dmx
            newphi = sum(w*(Fm-d)**2)+epst*sum(uttmp)-sum(log(((uttmp**2-dmt**2))))/t-sum(log(((uxtmp**2-dmx**2))))/t+epsx*sum(uxtmp)
            if (newphi-phi <= alpha*s*(sum(g1*delm))) then 
               exit
            else
               s = beta*s   
            end if
         end do
        
         write(0,*) "Backtracking loops", q 
         m=mtmp
         ux=uxtmp
         ut=uttmp
         call to_history("n1",n1,"res.H")
         call to_history("d1",0.004,"res.H")
         call to_history("n2",n2,"res.H")
         call to_history("n3",niter,"res.H")
         call srite("res.H",Fm-d,n*4)
         write(0,*) "step size", s
         write(0,*) "Fmodel point 1",    Fm(1)
         write(0,*) "delm point 1"  ,    delm(1)*s
         
         if (s <0.001 .or. sum(delm)/n < .001) then
            write(0,*) "mmmmmmmmmmmmmmmmmmmm"
            write(0,*) "step is little"
            exit
         end if
        
         !call to_history("n1",n1,"ModelNoReg.H")
         !call to_history("d1",0.004,"ModelNoReg.H")
         !call to_history("n2",n2,"ModelNoReg.H")
         !call to_history("n3",niter,"ModelNoReg.H")
         !call srite("ModelNoReg.H",sqrt(m),n*4)
      end do
      deallocate(z,Fm,Ftz,u)
      deallocate(dmx)
      deallocate(mtmp,utmp,nu)
      deallocate(D1,g1,delu,delm)
      call sep_close()
    end subroutine NewsolverA_test
  end module NewsolverA
