program rms2int_2d_2fit
  use sep
  use vrms2int_2d_2fit

  implicit none
  integer                          :: i1, i2, n1, n2, niter, stat,nq
  real                             :: eps,alphax,alphat,epsx,epst,o1,o2,d1,d2
  real, dimension (:), allocatable :: vint, vrms,dat
  real, dimension (:), pointer     :: weight,qx,qz

  call sep_init ()

  call from_history ("n1",n1)
  call from_history ("o1",o1)
  call from_history ("d1",d1)
  call from_history ("n2",n2)
  call from_history ("o2",o2)
  call from_history ("d2",d2)

  call from_par ("niter",niter,20)
  call from_par ("nq",nq,5)
  call from_par ("eps",eps,1.)
  call from_par ("epsx",epsx,1.)
  call from_par ("epst",epst,1.)
  call from_par ("alphax",alphax,1.)
  call from_par ("alphat",alphat,1.)

  call to_history ("title","Interval velocity")
  call to_history ("n1",n1)

  allocate( vint(n1*n2), vrms(n1*n2), weight(n1*n2),dat(n1*n2),qx(n1*n2),qz(n1*n2))

  vint = 0; weight=0

  call sep_read (vrms); vrms = 1./vrms
  weight=1;
  if(exist_file("weight")) call sep_read (weight, file="weight")

  call vrms2int_2d_2fit_exe( niter, eps, epsx,epst, weight, vrms, vint, nq,alphax,alphat,n1,n2,dat,qx,qz)

  vint = 1./vint
  call sep_write (vint) 
  if( exist_file("qx")) then
     call sep_write( qx, "qx")
     call to_history ("n1",n1,"qx")
     call to_history ("n2",n2,"qx")
     call to_history ("n3",1,"qx")
     call to_history ("o1",o1,"qx")
     call to_history ("d1",d1,"qx")
     call to_history ("o2",o2,"qx")
     call to_history ("d2",d2,"qx")
  end if
  if( exist_file("qz")) then
     call sep_write( qz, "qz")
     call to_history ("n1",n1,"qz")
     call to_history ("n2",n2,"qz")
     call to_history ("n3",1,"qz")
     call to_history ("o1",o1,"qz")
     call to_history ("d1",d1,"qz")
     call to_history ("o2",o2,"qz")
     call to_history ("d2",d2,"qz")
  end if



  call sep_close ()

  deallocate (vint, vrms, weight,dat,qx,qz)
  call exit (0)


end program rms2int_2d_2fit

