program rms2int_2d_GradMag
  use sep
  use vrms2int_2d_GradMag

  implicit none
  integer                          :: i1, i2, n1, n2, niter, stat,nq
  real                             :: eps,alpha,o1,o2,d1,d2
  real, dimension (:), allocatable :: vint, vrms,dat
  real, dimension (:), pointer     :: weight,q

  call sep_init ()
  call from_history ("n1",n1)
  call from_history ("o1",o1)
  call from_history ("d1",d1)
  call from_history ("n2",n2)
  call from_history ("o2",o2)
  call from_history ("d2",d2)

  call from_par ("niter",niter,20)
  call from_par ("nq",nq,5)
  call from_par ("eps",eps,1.)
  call from_par ("alpha",alpha,1.)

  call to_history ("title","Interval velocity")
  call to_history ("n1",n1)

  allocate( vint(n1*n2), vrms(n1*n2), weight(n1*n2),dat(n1*n2),q(n1*n2))

  vint = 0; weight=0

  call sep_read (vrms); vrms = 1./vrms
  weight=1;
  if(exist_file("weight")) call sep_read (weight, file="weight")

  call vrms2int_2d_GradMag_exe( niter, eps, weight, vrms, vint, nq,alpha,n1,n2,dat,q)
  
   if( exist_file("q")) then
     call sep_write( q, "q")
     call to_history ("n1",n1,"q")
     call to_history ("n2",n2,"q")
     call to_history ("n3",1,"q")
     call to_history ("o1",o1,"q")
     call to_history ("d1",d1,"q")
     call to_history ("o2",o2,"q")
     call to_history ("d2",d2,"q")
   end if

  vint = 1./vint
  call sep_write (vint) 
  call sep_close ()

  deallocate (vint, vrms, weight, q, dat)
  call exit (0)


end program rms2int_2d_GradMag

