program VrmsNewA
  use sep
  use NewsolverA
  use causint1
  !use igrad1
  !use gradchain_2fit_mod
  !use grads

  implicit none
  integer                          :: niter,maxiter, ix,it,n1,n2
!  integer, pointer                 :: n1,n2
  real, dimension (:), allocatable :: vint, vrms, dat
  !real, dimension (:), allocatable :: vint, vrms
  real, dimension (:), pointer     :: weight
  real                             :: epsx, epst

  call sep_init ()
  call from_history (n1)
  call from_either ("n2",n2,1)

  call to_history ("title","Interval velocity")
  call to_history ("n1",n1)
  call to_history ("n1",n1,"vrms")
  call to_history ("title","RMS velocity","vrms")
  call to_history ("esize",4,"vrms")
  write(0,*) "MMMMMMMMMMMMMMMMMMMMM"
  write(0,*) n1
  allocate( vint(n1*n2), vrms(n1*n2), weight(n1*n2), dat(n1*n2) )
  
  vint = 0.     
  do ix= 1, n2  
     vint(1 + (ix-1)*n1 ) = dat(1 + (ix-1)*n1 )
  end do
  
  call causint1_init(n1)
  
  call sep_read (vrms);
  call from_par("epsx",epsx)
  call from_par("epst",epst)
  call from_par("maxiter",maxiter)
  call from_par("niter",niter)

  vrms = 1./vrms
  !write(0,*) "data point 1", vrms(1)
  !write(0,*) "data point 1500", vrms(1500)
  !write(0,*) "data point 3000", vrms(3000)
  !write(0,*) "data point 4600", vrms(4600)
  !write(0,*) "data ponit 60000", vrms(60000)
  do ix= 1, n2  
     do it= 1, n1  
        dat( it+(ix-1)*n1) = vrms( it+(ix-1)*n1) * vrms( it+(ix-1)*n1)* it
        weight( it+(ix-1)*n1) = (12./it)      
        
     end do
  end do
  call to_history("n1",n1,"dat.H")
  call to_history("d1",0.004,"dat.H")
  call to_history("n2",n2,"dat.H")
  call srite("dat.H",dat,n1*n2*4)
  !write(0,*) "BBBBBBBBBBBBBBBBBB"
  !write(0,*) epsx,epst
  
  call NewsolverA_test(vint,dat,causint1_lop,weight,niter,maxiter,epsx,epst,n1,n2)
  !vint=1./vint
  vint=sqrt(vint)
  
  call sep_write(vint)

  call sep_close ()

  deallocate (vint, vrms, weight,dat)
  call exit (0)

end program VrmsNewA
