!$=head1 NAME
!$
!$causint - Causal integration
!$
!$=head1 SYNOPSIS
!$
!$C<ierr=causint_lop(adj,add,x,y)>
!$
!$=head1 PARAMETERS
!$
!$=over 4
!$
!$=item adj,add,x,y  -
!$
!$      standard operator interface
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Causal integration
!$
!$=head1 SEE ALSO
!$
!$L<cdoubint>
!$
!$=head1 LIBRARY
!$
!$B<geef90>
!$
!$=cut
     module causint1  
! causal integration
     use adj_mod
     implicit none
     integer, private,save :: n1

     contains
     subroutine causint1_init ( n1_in )
     integer            ::n1_in
     n1=n1_in
     write(0,*)"n1_in,n1",n1_in,n1
     end subroutine

     function causint1_lop ( adj, add, xx, yy) result(stat)
       integer            :: stat 
       logical,intent(in) :: adj,add 
       real,dimension(:)  :: xx,yy 
       call adjnull (adj,add,xx,yy )
       call causint1_lop2(adj,add,xx,yy)
       stat=0
     end function 
     
      subroutine causint1_lop2(adj,add,xx,yy)
        logical,intent(in) :: adj,add 
        real, dimension (:)  :: xx 
        real, dimension (:)  :: yy 
        integer i, n       
        real t
         n = size (xx)
         !write(0,*) "HHHHHHHHHHHHHHHHHHH", n
         t = 0.
         if ( adj) then
          do i= n, 1, -1  
           t = t + yy(i)
           xx(i) = xx(i) + t
           if( mod(i-1,n1)==0 ) t=0
          end do
        else
          do i= 1, n  
           t   = t + xx(i)
           yy(i) = yy(i) + t
           if( mod(i,n1)==0 ) t=0
          end do
        end if
      end subroutine 

      subroutine causint1_close()
      end subroutine 

     end module 
