# 1 "<stdin>"
# 1 "<built-in>"
# 1 "<command line>"
# 1 "<stdin>"
!$
!$=head1 NAME
!$
!$matmult - matrix multiplication
!$
!$=head1 SYNOPSIS
!$
!$C<call matmult_init(bb)>
!$
!$C<ierr=matmult_lop(adj,add,model,data)>
!$
!$=head1 PARAMETERS
!$
!$=over 4
!$
!$=item bb C<real(:,:)>
!$
!$ Matrix
!$
!$=item adj,add,model,data
!$
!$ Standard operator interface
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Matrix multiplication
!$
!$=head1 LIBRARY
!$
!$B<geef90>
!$
!$=cut
!$
module matmult2d
! matrix multiply and its adjoint
  use adj_mod
  implicit none
  real ,private, dimension (:,:), pointer :: bb
  integer, private                        :: n1,n2
  contains
  subroutine matmult2d_init ( bb_in ,n1_in, n2_in)
    real , dimension (:,:), pointer :: bb_in
    integer                         ::n1_in,n2_in
    bb => bb_in
    n1 = n1_in
    n2 = n2_in
  end subroutine
  function matmult2d_lop( adj, add, x, y) result(stat)
    integer :: stat
    logical,intent(in) :: adj,add
    real,dimension(:) :: x,y
    call adjnull (adj,add,x,y )
    call matmult2d_lop2(adj,add,x,y)
    stat=0
  end function
  subroutine matmult2d_lop2(adj,add,x,y)
    logical,intent(in) :: adj,add
    real, dimension (:) :: x
    real, dimension (:) :: y
    real, dimension (:,:), allocatable:: model,dat
    integer ix, iy, iz
    !write(0,*) "AAAAAAAAAAAAAAAAAA", shape(bb),shape(x),shape(y)
    allocate(model(n1,n2),dat(n1,n2))
    !write(0,*) adj
    !write(0,*) "AAAAAAAAAAAAAAAAAAAAAAAAAAAAA", shape(dat)
    !write(0,*) size(
    !write(0,*) "AAAAAAAAAA",shape(model)
    !write(0,*) "here"
    model=reshape(x,(/n1,n2/))
    dat  =reshape(y,(/n1,n2/))
    !write(0,*) "n1", n1
    !write(0,*) "n2", n2
    !write(0,*) "n1*n2", n1*n2
    !write(0,*) "shape", shape(bb)
    do iz= 1, n2
       !write(0,*) "iz",iz
       !write(0,*) "adj",adj
       do ix= 1, n1!size(y)
          do iy= 1, n1!size(x)
             !write(0,*) "ix",ix
             !write(0,*) "iz",iz
             !write(0,*) "adj",adj
             if ( adj) then
                model(ix,iz) = model(ix,iz) + bb(iy,ix) * dat(iy,iz)
             else
                dat(iy,iz) = dat(iy,iz) + bb(iy,ix) * model(ix,iz)
             end if
          end do
       end do
    end do
    !write(0,*) adj
    !write(0,*) "AAAAAAAAAAAAAAAAAAAAAAAAAAAAA", shape(dat)
    y=reshape(dat,(/n1*n2/))
    x=reshape(model,(/n1*n2/))
  end subroutine matmult2d_lop2
  subroutine matmult_close()
  end subroutine matmult_close
end module matmult2d
